//! event ch.spaces-to-tabs: spacesToTabs
//! event ch.tabs-to-spaces: tabsToSpaces

function spacesToTabs() { convert(true); }
function tabsToSpaces() { convert(false); }

function convert(convertSpaces) {
   Recipe.run(function(rctx) {
      
      if (rctx.length() == 0)
         return;
      
      // Get the selected range or document range
      var sel = rctx.selection;
      if (sel.length == 0)
         sel = NSMakeRange(0, rctx.length());
      
      var text = rctx.textInRange(sel);
      var tabsize = Context.tabInfo().tabSize;
      
      if (convertSpaces) {
         // Find any sequence of spaces between 2 and $tabsize
         text = text.replace(RegExp(" {2," + String(tabsize) + "}", "g"), "\t");
      }
      else {
         // Find \t and replace with " " * tabsize
         text = text.replace(/\t/g, " ".repeat(tabsize));
      }
      
      rctx.replaceTextInRange(sel, text);
   });
}